<!-- This WebApp/WebSite was created using BANano v2.09, a B4X library written by Alain Bailleul (2018 - 2019). -->
/* Umbrella (modified by Alain Bailleul) */
var u = function (t, e) {
    return this instanceof u ? t instanceof u ? t : ("string" == typeof t && (t = this.select(t, e)), t && t.nodeName && (t = [t]), void(this.nodes = this.slice(t))) : new u(t, e)
};
u.prototype = {
    get length() {
        return this.nodes.length
    }
}, u.prototype.nodes = [], u.prototype.addClass = function () {
    return this.eacharg(arguments, function (t, e) {
        t.classList.add(e)
    })
}, u.prototype.adjacent = function (i, t, n) {
    return "number" == typeof t && (t = 0 === t ? [] : new Array(t).join().split(",").map(Number.call, Number)), this.each(function (r, o) {
        var e = document.createDocumentFragment();
        u(t || {}).map(function (t, e) {
            var n = "function" == typeof i ? i.call(this, t, e, r, o) : i;
            return "string" == typeof n ? this.generate(n) : u(n)
        }).each(function (t) {
            this.isInPage(t) ? e.appendChild(u(t).clone().first()) : e.appendChild(t)
        }), n.call(this, r, e)
    })
}, u.prototype.after = function (t, e) {
    return this.adjacent(t, e, function (t, e) {
        t.parentNode.insertBefore(e, t.nextSibling)
    })
}, u.prototype.append = function (t, e) {
    return this.adjacent(t, e, function (t, e) {
        t.appendChild(e)
    })
}, u.prototype.args = function (t, e, n) {
    return "function" == typeof t && (t = t(e, n)), "string" != typeof t && (t = this.slice(t).map(this.str(e, n))), t.toString().split(/[\s,]+/).filter(function (t) {
        return t.length
    })
}, u.prototype.array = function (o) {
    o = o;
    var i = this;
    return this.nodes.reduce(function (t, e, n) {
        var r;
        return o ? ((r = o.call(i, e, n)) || (r = !1), "string" == typeof r && (r = u(r)), r instanceof u && (r = r.nodes)) : r = e.innerHTML, t.concat(!1 !== r ? r : [])
    }, [])
}, u.prototype.attr = function (t, e, r) {
    return r = r ? "data-" : "", this.pairs(t, e, function (t, e) {
        return t.getAttribute(r + e)
    }, function (t, e, n) {
        t.setAttribute(r + e, n)
    })
}, u.prototype.before = function (t, e) {
    return this.adjacent(t, e, function (t, e) {
        t.parentNode.insertBefore(e, t)
    })
}, u.prototype.children = function (t) {
    return this.map(function (t) {
        return this.slice(t.children)
    }).filter(t)
}, u.prototype.clone = function () {
    return this.map(function (t, e) {
        var n = t.cloneNode(!0),
            r = this.getAll(n);
        return this.getAll(t).each(function (t, e) {
            for (var n in this.mirror) this.mirror[n] && this.mirror[n](t, r.nodes[e])
        }), n
    })
}, u.prototype.toU = function () {
    for (var t = [], e = 0; e < this.nodes.length; e++) t.push(u(this.nodes[e]));
    return t
}, u.prototype.css = function (t, e) {
    return this.pairs(t, e, function (t, e) {
        return getStyle(t, e)
    }, function (t, e, n) {
        setStyle(t, e, n)
    })
}, u.prototype.getAll = function (t) {
    return u([t].concat(u("*", t).nodes))
}, u.prototype.mirror = {}, u.prototype.mirror.events = function (t, e) {
    if (t._e)
        for (var n in t._e) t._e[n].forEach(function (t) {
            u(e).on(n, t)
        })
}, u.prototype.mirror.select = function (t, e) {
    u(t).is("select") && (e.value = t.value)
}, u.prototype.mirror.textarea = function (t, e) {
    u(t).is("textarea") && (e.value = t.value)
}, u.prototype.closest = function (e) {
    return this.map(function (t) {
        do {
            if (u(t).is(e)) return t
        } while ((t = t.parentNode) && t !== document)
    })
}, u.prototype.data = function (t, e) {
    return this.attr(t, e, !0)
}, u.prototype.each = function (t) {
    return this.nodes.forEach(t.bind(this)), this
}, u.prototype.eacharg = function (n, r) {
    return this.each(function (e, t) {
        this.args(n, e, t).forEach(function (t) {
            r.call(this, e, t)
        }, this)
    })
}, u.prototype.empty = function () {
    return this.each(function (e) {
        for (var t = e.children, r = 0; r < t.length; r++) {
            var i = t[r];
            var n = document.getElementById(i.id);
            if (n) {
                var o = n.cloneNode(!0);
                n.parentNode.replaceChild(o, n)
            }
        }
        for (; e.firstChild;) e.removeChild(e.firstChild)
    })
}, u.prototype.filter = function (e) {
    var t = function (t) {
        return t.matches = t.matches || t.msMatchesSelector || t.webkitMatchesSelector, t.matches(e || "*")
    };
    return "function" == typeof e && (t = e), e instanceof u && (t = function (t) {
        return -1 !== e.nodes.indexOf(t)
    }), u(this.nodes.filter(t))
}, u.prototype.find = function (e) {
    return this.map(function (t) {
        return u(e || "*", t)
    })
}, u.prototype.first = function () {
    return this.nodes[0] || !1
}, u.prototype.bananofirst = function () {
    return u(this.nodes[0]) || !1
}, u.prototype.generate = function (t) {
    return /^\s*<tr[> ]/.test(t) ? u(document.createElement("table")).html(t).children().children().nodes : /^\s*<t(h|d)[> ]/.test(t) ? u(document.createElement("table")).html(t).children().children().children().nodes : /^\s*</.test(t) ? u(document.createElement("div")).html(t).children().nodes : document.createTextNode(t)
}, u.prototype.handle = function () {
    var t = this.slice(arguments).map(function (e) {
        return "function" == typeof e ? function (t) {
            t.preventDefault(), e.apply(this, arguments)
        } : e
    }, this);
    return this.on.apply(this, t)
}, u.prototype.hasClass = function () {
    return this.is("." + this.args(arguments).join("."))
}, u.prototype.html = function (e) {
    return void 0 === e ? this.first().innerHTML || "" : this.each(function (t) {
        t.innerHTML = e
    })
}, u.prototype.is = function (t) {
    return 0 < this.filter(t).length
}, u.prototype.isInPage = function (t) {
    return t !== document.body && document.body.contains(t)
}, u.prototype.bananolastlast = function () {
    return u(this.nodes[this.length - 1]) || !1
}, u.prototype.last = function () {
    return this.nodes[this.length - 1] || !1
}, u.prototype.map = function (t) {
    return t ? u(this.array(t)).unique() : this
}, u.prototype.not = function (e) {
    return this.filter(function (t) {
        return !u(t).is(e || !0)
    })
}, u.prototype.off = function (t) {
    return this.eacharg(t, function (e, n) {
        u(e._e ? e._e[n] : []).each(function (t) {
            e.removeEventListener(n, t)
        })
    })
}, u.prototype.on = function (t, e, r) {
    if ("string" == typeof e) {
        var o = e;
        e = function (e) {
            var n = arguments;
            u(e.currentTarget).find(o).each(function (t) {
                if (t === e.target || t.contains(e.target)) {
                    try {
                        Object.defineProperty(e, "currentTarget", {
                            get: function () {
                                return t
                            }
                        })
                    } catch (t) {}
                    r.apply(t, n)
                }
            })
        }
    }
    var n = function (t) {
        return e.apply(this, [t].concat(t.detail || []))
    };
    return this.eacharg(t, function (t, e) {
        t.addEventListener(e, n), t._e = t._e || {}, t._e[e] = t._e[e] || [], t._e[e].push(n)
    })
}, u.prototype.pairs = function (n, t, e, r) {
    if (void 0 !== t) {
        var o = n;
        (n = {})[o] = t
    }
    return "object" == typeof n ? this.each(function (t) {
        for (var e in n) r(t, e, n[e])
    }) : this.length ? e(this.first(), n) : ""
}, u.prototype.param = function (e) {
    return Object.keys(e).map(function (t) {
        return this.uri(t) + "=" + this.uri(e[t])
    }.bind(this)).join("&")
}, u.prototype.parent = function (t) {
    return this.map(function (t) {
        return t.parentNode
    }).filter(t)
}, u.prototype.prepend = function (t, e) {
    return this.adjacent(t, e, function (t, e) {
        t.insertBefore(e, t.firstChild)
    })
}, u.prototype.remove = function () {
    return this.each(function (t) {
        u(t).empty();
        t.parentNode && t.parentNode.removeChild(t)
    })
}, u.prototype.removeClass = function () {
    return this.eacharg(arguments, function (t, e) {
        t.classList.remove(e)
    })
}, u.prototype.replace = function (t, e) {
    var n = [];
    return this.adjacent(t, e, function (t, e) {
        n = n.concat(this.slice(e.children)), t.parentNode.replaceChild(e, t)
    }), u(n)
}, u.prototype.scroll = function () {
    return this.first().scrollIntoView({
        behavior: "smooth"
    }), this
}, u.prototype.select = function (t, e) {
    return t = t.replace(/^\s*/, "").replace(/\s*$/, ""), /^</.test(t) ? u().generate(t) : (e || document).querySelectorAll(t)
}, u.prototype.serialize = function () {
    var r = this;
    return this.slice(this.first().elements).reduce(function (e, n) {
        return !n.name || n.disabled || "file" === n.type ? e : /(checkbox|radio)/.test(n.type) && !n.checked ? e : "select-multiple" === n.type ? (u(n.options).each(function (t) {
            t.selected && (e += "&" + r.uri(n.name) + "=" + r.uri(t.value))
        }), e) : e + "&" + r.uri(n.name) + "=" + r.uri(n.value)
    }, "").slice(1)
}, u.prototype.siblings = function (t) {
    return this.parent().children(t).not(this)
}, u.prototype.size = function () {
    return this.first().getBoundingClientRect()
}, u.prototype.hasAttr = function (t) {
    return null != this.attr(t)
}, u.prototype.slice = function (t) {
    return t && 0 !== t.length && "string" != typeof t && "[object Function]" !== t.toString() ? t.length ? [].slice.call(t.nodes || t) : [t] : []
}, u.prototype.str = function (e, n) {
    return function (t) {
        return "function" == typeof t ? t.call(this, e, n) : t.toString()
    }
}, u.prototype.text = function (e) {
    return void 0 === e ? this.first().textContent || "" : this.each(function (t) {
        t.textContent = e
    })
}, u.prototype.toggleClass = function (t, e) {
    return !!e === e ? this[e ? "addClass" : "removeClass"](t) : this.eacharg(t, function (t, e) {
        t.classList.toggle(e)
    })
}, u.prototype.trigger = function (t) {
    var o = this.slice(arguments).slice(1);
    return this.eacharg(t, function (t, e) {
        var n, r = {
            bubbles: !0,
            cancelable: !0,
            detail: o
        };
        try {
            n = new window.CustomEvent(e, r)
        } catch (t) {
            (n = document.createEvent("CustomEvent")).initCustomEvent(e, !0, !0, o)
        }
        t.dispatchEvent(n)
    })
}, u.prototype.checked = function (bool) {
    if (bool === undefined) {
        return this.checked().value || false;
    }
    return this.each(function (node) {
        node.checked = bool;
    });
}, u.prototype.value = function (text) {
    if (text === undefined) {
        return this.first().value || '';
    }
    return this.each(function (node) {
        node.value = text;
    });
}, u.prototype.unique = function () {
    return u(this.nodes.reduce(function (t, e) {
        return null != e && !1 !== e && -1 === t.indexOf(e) ? t.concat(e) : t
    }, []))
}, u.prototype.uri = function (t) {
    return encodeURIComponent(t).replace(/!/g, "%21").replace(/'/g, "%27").replace(/\(/g, "%28").replace(/\)/g, "%29").replace(/\*/g, "%2A").replace(/%20/g, "+")
}, u.prototype.wrap = function (t) {
    return this.map(function (e) {
        return u(t).each(function (t) {
            (function (t) {
                for (; t.firstElementChild;) t = t.firstElementChild;
                return u(t)
            })(t).append(e.cloneNode(!0)), e.parentNode.replaceChild(t, e)
        })
    })
}, "object" == typeof module && module.exports && (module.exports = u, module.exports.u = u); /* bananojqm */
function banano_bananojqm_jqmapp() {
    var self;
    this._appname = '';
    this.initialize = function (_sappname) {
        if (self == null) self = this;
        var _elbody;
        self._appname = _sappname;
        _elbody = null;
        _elbody = u("#body");
        _elbody.empty();
    };
    this.addpage = function (_eventhandler, _pg) {
        if (self == null) self = this;
        var _pgcode;
        _pgcode = _pg.tostring();
        _pg.append("body", _pgcode);
        _pg.bindevents("", _eventhandler);
    };
}

function banano_bananojqm_jqmpage() {
    var self;
    this._id = '';
    this._header = new banano_bananojqm_jqmcontainer();
    this._content = new banano_bananojqm_jqmcontainer();
    this._footer = new banano_bananojqm_jqmcontainer();
    this._page = new banano_bananojqm_jqmcontainer();
    this._title = '';
    this._cache = false;
    this._dataurl = '';
    this._fullscreen = false;
    this._theme = '';
    this._events = {};
    this._app = new banano_bananojqm_jqmapp();
    this.initialize = function (_thisapp, _sid) {
        if (self == null) self = this;
        self._app = _thisapp;
        self._events = {};
        self._events = {};
        self._id = _sid.toLowerCase();
        self._header.initialize(self, "" + self._id + "hdr");
        self._header.setattrdata("role", "header");
        self._content.initialize(self, "" + self._id + "cnt");
        self._content.setattrdata("role", "main");
        self._content.addclass("ui-content");
        self._footer.initialize(self, "" + self._id + "ftr");
        self._footer.setattrdata("role", "footer");
        self._page.initialize(self, self._id);
        self._page._element.setdatarole("page");
        self._cache = false;
        self._dataurl = "";
        self._fullscreen = false;
        self._theme = "";
    };
    this.tostring = function () {
        if (self == null) self = this;
        if (self._theme.length > 0) {
            self._page._element.setattrdata("theme", self._theme);
        }
        if (self._fullscreen) {
            self._page._element.setattrdata("fullscreen", true);
        }
        if (self._cache) {
            self._page._element.setattrdata("dom-cache", "true");
        }
        if (self._title.length > 0) {
            self._page._element.setattrdata("data-title", self._title);
        }
        if (self._dataurl.length > 0) {
            self._page._element.setattrdata("url", self._dataurl);
        }
        self._page._element.addcontent(self._header.tostring());
        self._page._element.addcontent(self._content.tostring());
        self._page._element.addcontent(self._footer.tostring());
        return self._page.tostring();
    };
    this.append = function (_elid, _elcontent) {
        if (self == null) self = this;
        _elid = _elid.toLowerCase();
        u("#" + _elid + "").append(_elcontent);
    };
    this.bindevents = function (_eventname, _eventhandler) {
        if (self == null) self = this;
        var _ktot;
        var _kcnt;
        var _strbtn;
        var _sevent;
        var _skey;
        var _elm;
        _ktot = Object.keys(self._events).length - 1;
        _kcnt = 0;
        for (_kcnt = 0; _kcnt <= _ktot; _kcnt++) {
            _strbtn = banano_getB4JKeyAt(self._events, _kcnt);
            _sevent = self._events[_strbtn];
            _skey = "#" + _strbtn + "";
            _skey = _skey.toLowerCase();
            _sevent = "" + _strbtn + "_" + _sevent + "";
            if (_eventname.length > 0) {
                _sevent = _eventname;
            }
            _sevent = _sevent.toLowerCase();
            if (_eventhandler != null) {
                _elm = u(_skey);
                _elm.off(_sevent);
                _elm.handle(_sevent, function (event) {
                    if (typeof _eventhandler[_sevent] === "function") {
                        return _eventhandler[_sevent](event)
                    }
                });
            }
        }
    };
    this.addevent = function (_btnid, _elevent) {
        if (self == null) self = this;
        _btnid = _btnid.toLowerCase();
        _btnid = _btnid.trim();
        if (_btnid.length > 0) {
            self._events[_btnid] = _elevent;
        }
    };
}

function banano_bananojqm_html5() {
    var self;
    this._id = '';
    this._instance = '';
    this._properties = {};
    this._contents = [];
    this._classes = {};
    this._styles = {};
    this._looseattributes = [];
    this._dontbreak = [];
    this._prefix = '';
    this._doaproperclose = false;
    this._required = false;
    this._enabled = false;
    this._inline = false;
    this._readonly = false;
    this._cssrule = {};
    this._singlequote = [];
    this._parentid = '';
    this._text = '';
    this._textafter = false;
    this.getstyleattribute = function (_attr) {
        if (self == null) self = this;
        var _hasitem;
        _attr = _attr.toLowerCase();
        _attr = self.remdelim(_attr, ":").trim();
        _hasitem = (_attr in self._styles);
        if (_hasitem) {
            return self._styles[_attr];
        } else {
            return "";
        }
    };
    this.setcontents = function (_value) {
        if (self == null) self = this;
        self._contents.length = 0;
        self._contents.length = 0;
        if (_value.length > 0) {
            _value = self.formattext(_value);
            self._contents.push(_value);
        }
        return self;
    };
    this.addelementline = function (_el) {
        if (self == null) self = this;
        var _scode;
        if (_el != null) {
            _scode = _el.html();
            self.addcontent(_scode);
        }
        return self;
    };
    this.setdatarole = function (_svalue) {
        if (self == null) self = this;
        self.addattribute("data-role", _svalue);
        return self;
    };
    this.setrole = function (_svalue) {
        if (self == null) self = this;
        self.addattribute("role", _svalue);
        return self;
    };
    this.addcontentline = function (_value) {
        if (self == null) self = this;
        if (_value != "") {
            _value = _value.split("\n").join("");
            _value = self.formattext(_value);
            self._contents.push(_value);
        }
        return self;
    };
    this.settypenumbers = function () {
        if (self == null) self = this;
        self.addattribute("type", "1");
        return self;
    };
    this.settypeuppercase = function () {
        if (self == null) self = this;
        self.addattribute("type", "A");
        return self;
    };
    this.settypelowercase = function () {
        if (self == null) self = this;
        self.addattribute("type", "a");
        return self;
    };
    this.settypeuppercaseroman = function () {
        if (self == null) self = this;
        self.addattribute("type", "I");
        return self;
    };
    this.settypelowercaseroman = function () {
        if (self == null) self = this;
        self.addattribute("type", "i");
        return self;
    };
    this.setliststylecircle = function () {
        if (self == null) self = this;
        self.addstyleattribute("list-style-type", "circle");
        return self;
    };
    this.setliststyledisk = function () {
        if (self == null) self = this;
        self.addstyleattribute("list-style-type", "disk");
        return self;
    };
    this.setliststylenone = function () {
        if (self == null) self = this;
        self.addstyleattribute("list-style-type", "none");
        return self;
    };
    this.setliststylesquare = function () {
        if (self == null) self = this;
        self.addstyleattribute("list-style-type", "square");
        return self;
    };
    this.addheading = function (_ssize, _scontent) {
        if (self == null) self = this;
        var _hdr;
        var _hkey;
        _hdr = new banano_bananojqm_html5();
        _hkey = "h" + _ssize;
        _hdr.initialize("", _hkey);
        _hdr.addcontent(_scontent);
        self.addcontent(_hdr.html());
        return self;
    };
    this.addparagraph = function (_scontent) {
        if (self == null) self = this;
        var _p;
        _p = new banano_bananojqm_html5();
        _p.initialize("", "p");
        _p.addcontent(_scontent);
        self.addcontent(_p.html());
        return self;
    };
    this.addlooseattributeonfalsecondition = function (_bstatus, _value) {
        if (self == null) self = this;
        self.removeattr(_value);
        if (_bstatus == false) {
            self.addlooseattribute(_value);
        }
        return self;
    };
    this.setelementtypeoncondition = function (_bstatus, _selementtype) {
        if (self == null) self = this;
        if (_bstatus) {
            self._instance = _selementtype;
        }
        return self;
    };
    this.setzindex = function (_zindex) {
        if (self == null) self = this;
        self.addstyleattribute("z-index", _zindex);
        return self;
    };
    this.addcontentlistreverse = function (_lst) {
        if (self == null) self = this;
        var _ltot;
        var _lcnt;
        var _strcontent;
        _ltot = _lst.length - 1;
        _lcnt = 0;
        for (_lcnt = _ltot; _lcnt >= 0; _lcnt -= 1) {
            _strcontent = _lst[_lcnt];
            self.addcontent(_strcontent);
        }
        return self;
    };
    this.setfor = function (_sfor) {
        if (self == null) self = this;
        self.addattribute("for", _sfor);
        return self;
    };
    this.setvalue = function (_svalue) {
        if (self == null) self = this;
        self.addattribute("value", _svalue);
        return self;
    };
    this.setname = function (_sname) {
        if (self == null) self = this;
        self.addattribute("name", _sname);
        return self;
    };
    this.settype = function (_svalue) {
        if (self == null) self = this;
        self.addattribute("type", _svalue);
        return self;
    };
    this.updateattribute = function (_name, _propvalue) {
        if (self == null) self = this;
        var _svalue;
        if ((_name in self._properties)) {
            _svalue = self._properties[_name];
            _svalue = _svalue + ";" + _propvalue;
            self._properties[_name] = _svalue;
        } else {
            self._properties[_name] = _propvalue;
        }
        return self;
    };
    this.addlooseattributeoncondition = function (_bstatus, _value) {
        if (self == null) self = this;
        self.removeattr(_value);
        if (_bstatus == true) {
            self.addattribute(_value, "true");
        }
        return self;
    };
    this.addlooseattribute = function (_value) {
        if (self == null) self = this;
        self.removeattr(_value);
        self.addattribute(_value, "true");
        return self;
    };
    this.makepx = function (_svalue) {
        if (self == null) self = this;
        if (_svalue.endsWith("%")) {
            return _svalue;
        } else {
            if (_svalue.endsWith("px")) {
                return _svalue;
            } else {
                _svalue = _svalue.trim();
                _svalue = _svalue.split("px").join("");
                _svalue = "" + _svalue + "px";
                if (_svalue == "px") {
                    _svalue = "";
                }
                return _svalue;
            }
        }
    };
    this.setattrdata = function (_attribute, _value) {
        if (self == null) self = this;
        if (_attribute.startsWith("data-")) {
            self.addattribute(_attribute, _value);
        } else {
            self.addattribute("data-" + _attribute, _value);
        }
        return self;
    };
    this.setattrdataoncondition = function (_bcondition, _attribute, _value) {
        if (self == null) self = this;
        self.removeattrdata(_attribute);
        if (_bcondition == false) {
            return self;
        }
        self.setattrdata(_attribute, _value);
        return self;
    };
    this.setsrc = function (_svalue, _static) {
        if (self == null) self = this;
        var _tmpfile;
        _tmpfile = self.mvfield(_svalue, 1, "?");
        if (_static) {
            _svalue = _tmpfile;
        } else {
            _svalue = _tmpfile + "?" + DateTime.Now();
        }
        self.addattribute("src", _svalue);
        return self;
    };
    this.setalt = function (_svalue) {
        if (self == null) self = this;
        self.addattribute("alt", _svalue);
        return self;
    };
    this.setwidthpx = function (_width) {
        if (self == null) self = this;
        if (_width != "") {
            self.addstyleattribute("width", self.makepx(_width));
        }
        return self;
    };
    this.setwidth = function (_width) {
        if (self == null) self = this;
        if (_width != "") {
            self.addattribute("width", _width);
        }
        return self;
    };
    this.setheight = function (_height) {
        if (self == null) self = this;
        if (_height != "") {
            self.addattribute("height", _height);
        }
        return self;
    };
    this.setplaceholder = function (_splaceholder) {
        if (self == null) self = this;
        self.addattribute("placeholder", _splaceholder);
        return self;
    };
    this.setheightpx = function (_height) {
        if (self == null) self = this;
        if (_height != "") {
            self.addstyleattribute("height", self.makepx(_height));
        }
        return self;
    };
    this.addstyleattributeoncondition = function (_bcondition, _attr, _value) {
        if (self == null) self = this;
        self.removestyle(_attr);
        if (_bcondition == true) {
            self.addstyleattribute(_attr, _value);
        }
        return self;
    };
    this.addattributeoncondition = function (_bcondition, _attr, _value) {
        if (self == null) self = this;
        self.removeattr(_attr);
        if (_bcondition == true) {
            self.addattribute(_attr, _value);
        }
        return self;
    };
    this.getattribute = function (_attr) {
        if (self == null) self = this;
        _attr = _attr.toLowerCase();
        if ((_attr in self._properties)) {
            return self._properties[_attr];
        } else {
            return "";
        }
    };
    this.classexists = function (_value) {
        if (self == null) self = this;
        _value = _value.trim();
        if (_value.length > 0) {
            return (_value in self._classes);
        }
        return false;
    };
    this.html = function () {
        if (self == null) self = this;
        var _sout;
        _sout = self.tostring();
        return _sout;
    };
    this.addcursor = function () {
        if (self == null) self = this;
        self.addstyleattribute("cursor", "pointer");
        return self;
    };
    this.sethref = function (_value) {
        if (self == null) self = this;
        self.addattribute("href", _value);
        return self;
    };
    this.addclassonvalue = function (_ivalue, _sclass) {
        if (self == null) self = this;
        if (_ivalue > 0) {
            self.addclass(_sclass);
        }
        return self;
    };
    this.addclassoncondition = function (_bcondition, _sclass) {
        if (self == null) self = this;
        self.removeclass(_sclass);
        if (_bcondition == true) {
            self.addclass(_sclass);
        }
        return self;
    };
    this.addclassonfalsecondition = function (_bcondition, _sclass) {
        if (self == null) self = this;
        self.removeclass(_sclass);
        if (_bcondition == false) {
            self.addclass(_sclass);
        }
        return self;
    };
    this.removeclassoncondition = function (_bcondition, _sclass) {
        if (self == null) self = this;
        if (_bcondition == true) {
            self.removeclass(_sclass);
        }
        return self;
    };
    this.removeclassonfalsecondition = function (_bcondition, _sclass) {
        if (self == null) self = this;
        if (_bcondition == false) {
            self.removeclass(_sclass);
        }
        return self;
    };
    this.addcontentlist = function (_lst) {
        if (self == null) self = this;
        var _strcontent;
        for (var _strcontentindex = 0; _strcontentindex < _lst.length; _strcontentindex++) {
            _strcontent = _lst[_strcontentindex];
            self.addcontent(_strcontent);
        }
        return self;
    };
    this.settext = function (_stext, _bafter) {
        if (self == null) self = this;
        self._text = _stext;
        self._textafter = _bafter;
        return self;
    };
    this.setprefix = function (_sprefix) {
        if (self == null) self = this;
        self._prefix = _sprefix;
        return self;
    };
    this.setid = function (_sid) {
        if (self == null) self = this;
        _sid = _sid.toLowerCase();
        self._id = _sid;
        return self;
    };
    this.settag = function (_stag) {
        if (self == null) self = this;
        self._instance = _stag;
        return self;
    };
    this.setparentid = function (_sparentid) {
        if (self == null) self = this;
        self._parentid = _sparentid;
        return self;
    };
    this.setreadonly = function (_breadonly) {
        if (self == null) self = this;
        self._readonly = _breadonly;
        return self;
    };
    this.setinline = function (_binline) {
        if (self == null) self = this;
        self._inline = _binline;
        return self;
    };
    this.setenabled = function (_benabled) {
        if (self == null) self = this;
        self._enabled = _benabled;
        return self;
    };
    this.setrequired = function (_brequired) {
        if (self == null) self = this;
        self._required = _brequired;
        return self;
    };
    this.initialize = function (_elid, _eltag) {
        if (self == null) self = this;
        self._id = _elid.toLowerCase();
        self._properties = {};
        self._properties = {};
        self._contents.length = 0;
        self._contents.length = 0;
        self._styles = {};
        self._styles = {};
        self._classes = {};
        self._classes = {};
        self._looseattributes.length = 0;
        self._looseattributes.length = 0;
        self._parentid = "";
        self._dontbreak.length = 0;
        self._dontbreak.length = 0;
        self._dontbreak.push("li");
        self._dontbreak.push("a");
        self._dontbreak.push("i");
        self._dontbreak.push("span");
        self._dontbreak.push("img");
        self._instance = _eltag;
        self._prefix = "";
        self._doaproperclose = true;
        self._required = false;
        self._enabled = true;
        self._inline = false;
        self._readonly = false;
        self._cssrule = {};
        self._cssrule = {};
        self._singlequote.length = 0;
        self._singlequote.length = 0;
        self._text = "";
        self._textafter = false;
    };
    this.removeattrdata = function (_sdata) {
        if (self == null) self = this;
        if (_sdata.startsWith("data-")) {} else {
            _sdata = "data-" + _sdata + "";
        }
        self.removeattr(_sdata);
        return self;
    };
    this.removeattribute = function (_prop) {
        if (self == null) self = this;
        self.removeattr(_prop);
        return self;
    };
    this.removeattr = function (_sname) {
        if (self == null) self = this;
        var _sitems;
        var _strstyle;
        _sname = _sname.toLowerCase();
        _sname = _sname.split(" ").join(";");
        _sitems = self.strparse(";", _sname);
        for (var _strstyleindex = 0; _strstyleindex < _sitems.length; _strstyleindex++) {
            _strstyle = _sitems[_strstyleindex];
            _strstyle = _strstyle.trim();
            if ((_strstyle in self._properties)) {
                delete self._properties[_strstyle];
            }
        }
        return self;
    };
    this.removestyle = function (_stylename) {
        if (self == null) self = this;
        var _sitems;
        var _strstyle;
        _stylename = _stylename.trim();
        _stylename = _stylename.toLowerCase();
        _stylename = _stylename.split(" ").join(";");
        _sitems = self.strparse(";", _stylename);
        for (var _strstyleindex = 0; _strstyleindex < _sitems.length; _strstyleindex++) {
            _strstyle = _sitems[_strstyleindex];
            _strstyle = _strstyle.trim();
            if ((_strstyle in self._styles)) {
                delete self._styles[_strstyle];
            }
        }
        return self;
    };
    this.setattrloose = function (_value) {
        if (self == null) self = this;
        self.addattribute(_value, _value);
        return self;
    };
    this.getcomponentbuilder = function () {
        if (self == null) self = this;
        var _sb;
        var _sout;
        _sb = new StringBuilder();
        _sb.isinitialized = true;
        if (self._prefix.length > 0) {
            _sb.append(self._prefix);
            _sb.append("\n");
        }
        _sb.append("<");
        _sb.append(self._instance);
        _sb.append(" ");
        if (self._id.length > 0) {
            _sb.append(self.toproperty("id", self._id));
        }
        _sb.append(">");
        switch ("" + self._instance.toLowerCase()) {
            case "" + "img":
            case "" + "link":
            case "" + "meta":
            case "" + "input":
            case "" + "source":
                self._doaproperclose = false;
                break;
        }
        if (self._doaproperclose == true) {
            _sb.append("</");
            _sb.append(self._instance);
            _sb.append(">");
        }
        _sb.append("\n");
        _sout = _sb.toString();
        _sout = _sout.trim();
        return _sout;
    };
    this.toproperty = function (_sname, _svalue) {
        if (self == null) self = this;
        var _script;
        _sname = self.cstr(_sname);
        _svalue = self.cstr(_svalue);
        _sname = _sname.split("null").join("");
        _sname = _sname.split("undefined").join("");
        _svalue = _svalue.split("null").join("");
        _svalue = _svalue.split("undefined").join("");
        _sname = _sname.trim();
        _svalue = _svalue.trim();
        if (_sname.length > 0) {
            _script = "" + _sname + "=\"" + _svalue + "\"";
            _script = _script.trim();
            return _script;
        } else {
            return "";
        }
    };
    this.cstr = function (_o) {
        if (self == null) self = this;
        return "" + _o;
    };
    this.addcontent = function (_value) {
        if (self == null) self = this;
        _value = self.cstr(_value);
        if (_value.length > 0) {
            _value = self.formattext(_value);
            self._contents.push(_value);
        }
        return self;
    };
    this.removeclass = function (_classname) {
        if (self == null) self = this;
        var _sitems;
        var _strstyle;
        _classname = _classname.trim();
        _classname = _classname.split(" ").join(";");
        _sitems = self.strparse(";", _classname);
        for (var _strstyleindex = 0; _strstyleindex < _sitems.length; _strstyleindex++) {
            _strstyle = _sitems[_strstyleindex];
            _strstyle = _strstyle.trim();
            if ((_strstyle in self._classes)) {
                delete self._classes[_strstyle];
            }
        }
        return self;
    };
    this.addelement = function (_el) {
        if (self == null) self = this;
        var _scode;
        if (_el != null) {
            _scode = _el.tostring();
            self.addcontent(_scode);
        }
        return self;
    };
    this.buildclass = function () {
        if (self == null) self = this;
        var _sb;
        var _ktot;
        var _kcnt;
        var _strclass;
        _sb = new StringBuilder();
        _sb.isinitialized = true;
        _ktot = Object.keys(self._classes).length - 1;
        _kcnt = 0;
        _strclass = banano_getB4JKeyAt(self._classes, 0);
        _sb.append(_strclass);
        for (_kcnt = 1; _kcnt <= _ktot; _kcnt++) {
            _strclass = banano_getB4JKeyAt(self._classes, _kcnt);
            _sb.append(" ");
            _sb.append(_strclass);
        }
        return _sb.toString();
    };
    this.applystyle = function (_sstyle) {
        if (self == null) self = this;
        var _pieces;
        var _strpiece;
        var _attr;
        var _val;
        _sstyle = _sstyle.trim();
        _pieces = self.strparse(";", _sstyle);
        for (var _strpieceindex = 0; _strpieceindex < _pieces.length; _strpieceindex++) {
            _strpiece = _pieces[_strpieceindex];
            _attr = self.mvfield(_strpiece, 1, ":");
            _val = self.mvfield(_strpiece, 2, ":");
            _attr = _attr.trim();
            _val = _val.trim();
            if (_attr != "") {
                self.addstyleattribute(_attr, _val);
            }
        }
    };
    this.buildstyle = function () {
        if (self == null) self = this;
        var _sb;
        var _kcnt;
        var _ktot;
        var _strkey;
        var _strvalue;
        var _strline;
        _sb = new StringBuilder();
        _sb.isinitialized = true;
        _kcnt = 0;
        _ktot = Object.keys(self._styles).length - 1;
        _strkey = banano_getB4JKeyAt(self._styles, 0);
        _strvalue = self._styles[_strkey];
        _strline = self.tostyle(_strkey, _strvalue);
        _sb.append(_strline);
        for (_kcnt = 1; _kcnt <= _ktot; _kcnt++) {
            _strkey = banano_getB4JKeyAt(self._styles, _kcnt);
            _strvalue = self._styles[_strkey];
            _strline = self.tostyle(_strkey, _strvalue);
            _sb.append(" ");
            _sb.append(_strline);
        }
        return _sb.toString();
    };
    this.tostyle = function (_sname, _svalue) {
        if (self == null) self = this;
        var _sout;
        _sname = _sname.split("undefined").join("");
        _sname = _sname.split("null").join("");
        _svalue = _svalue.split("undefined").join("");
        _svalue = _svalue.split("null").join("");
        _sname = _sname.trim();
        _svalue = _svalue.trim();
        if (_sname.length > 0 && _svalue.length > 0) {
            if (_sname.endsWith(":")) {
                _sname = self.mvfield(_sname, 1, ":");
            }
            _sout = "" + _sname + ":" + _svalue + ";";
            if (_sout == ":;") {
                _sout = "";
            }
            return _sout;
        } else {
            return "";
        }
    };
    this.mvfieldfrom = function (_svalue, _iposition, _delimiter) {
        if (self == null) self = this;
        var _mvalues;
        var _tvalues;
        var _sb;
        var _startcnt;
        if (_svalue.length == 0) {
            return "";
        }
        _mvalues = [];
        _tvalues = 0;
        if (_svalue.endsWith(_delimiter)) {
            _svalue = _svalue + " ";
        }
        _mvalues = self.strparse(_delimiter, _svalue);
        _tvalues = _mvalues.length - 1;
        if (_tvalues < _iposition) {
            return _mvalues[_tvalues];
        }
        _sb = new StringBuilder();
        _sb.isinitialized = true;
        _startcnt = 0;
        _sb.append(_mvalues[_iposition]);
        for (_startcnt = _iposition + 1; _startcnt <= _tvalues; _startcnt++) {
            _sb.append(_delimiter);
            _sb.append(_mvalues[_startcnt]);
        }
        return _sb.toString();
    };
    this.open = function () {
        if (self == null) self = this;
        var _thisclass;
        var _thisstyle;
        var _strvalue;
        var _sb;
        var _ktot;
        var _kcnt;
        var _strkey;
        if (self._required == true) {
            self.setattrloose("required");
        }
        if (self._enabled == false) {
            self.setattrloose("disabled");
        }
        if (self._inline == true) {
            self.setattrloose("inline");
        }
        if (self._readonly == true) {
            self.setattrloose("readonly");
        }
        _thisclass = self.buildclass();
        _thisclass = _thisclass.trim();
        if (_thisclass.length > 0) {
            self.addattribute("class", _thisclass);
        }
        _thisstyle = self.buildstyle();
        _thisstyle = _thisstyle.trim();
        if (_thisstyle.length > 0) {
            self.addattribute("style", _thisstyle);
        }
        _strvalue = '';
        _sb = new StringBuilder();
        _sb.isinitialized = true;
        if (self._prefix.length > 0) {
            _sb.append(self._prefix);
            _sb.append("\n");
        }
        _sb.append("<");
        _sb.append(self._instance);
        _sb.append(" ");
        if (self._id.length > 0) {
            _sb.append(self.toproperty("id", self._id));
            _sb.append(" ");
        }
        _ktot = Object.keys(self._properties).length - 1;
        _kcnt = 0;
        _strkey = banano_getB4JKeyAt(self._properties, 0);
        _strvalue = self._properties[_strkey];
        if (self._singlequote.indexOf(_strkey) == -1) {
            _sb.append(self.toproperty(_strkey, _strvalue));
        } else {
            _sb.append(self.tosinglequoteproperty(_strkey, _strvalue));
        }
        for (_kcnt = 1; _kcnt <= _ktot; _kcnt++) {
            _strkey = banano_getB4JKeyAt(self._properties, _kcnt);
            _strvalue = self._properties[_strkey];
            _sb.append(" ");
            if (self._singlequote.indexOf(_strkey) == -1) {
                _sb.append(self.toproperty(_strkey, _strvalue));
            } else {
                _sb.append(self.tosinglequoteproperty(_strkey, _strvalue));
            }
        }
        _sb.append(">");
        _sb.append("\n");
        return _sb.toString();
    };
    this.tosinglequoteproperty = function (_sname, _svalue) {
        if (self == null) self = this;
        var _script;
        _script = "" + _sname + "='" + _svalue + "'";
        _script = _script.trim();
        if (_script == "=''") {
            _script = "";
        }
        return _script;
    };
    this.formattext = function (_stext) {
        if (self == null) self = this;
        var _rm;
        var _ktot;
        var _kcnt;
        var _strvalue;
        var _strrep;
        _rm = {};
        _rm = {};
        _rm = {};
        _rm["{U}"] = "<ins>";
        _rm["{/U}"] = "</ins>";
        _rm["¢"] = "&cent;";
        _rm["£"] = "&pound;";
        _rm["{SUP}"] = "<sup>";
        _rm["{/SUP}"] = "</sup>";
        _rm["¥"] = "&yen;";
        _rm["€"] = "&euro;";
        _rm["©"] = "&copy;";
        _rm["®"] = "&reg;";
        _rm["{POUND}"] = "&pound;";
        _rm["{/B}"] = "</b>";
        _rm["{I}"] = "<i>";
        _rm["{YEN}"] = "&yen;";
        _rm["{EURO}"] = "&euro;";
        _rm["{CODE}"] = "<code>";
        _rm["{/CODE}"] = "</code>";
        _rm["{COPYRIGHT}"] = "&copy;";
        _rm["{REGISTERED}"] = "&reg;";
        _rm["®"] = "&reg;";
        _rm["{B}"] = "<b>";
        _rm["{SMALL}"] = "<small>";
        _rm["{/SMALL}"] = "</small>";
        _rm["{EM}"] = "<em>";
        _rm["{/EM}"] = "</em>";
        _rm["{MARK}"] = "<mark>";
        _rm["{/MARK}"] = "</mark>";
        _rm["{/I}"] = "</i>";
        _rm["{SUB}"] = "<sub>";
        _rm["{/SUB}"] = "</sub>";
        _rm["{BR}"] = "<br/>";
        _rm["{WBR}"] = "<wbr>";
        _rm["{STRONG}"] = "<strong>";
        _rm["{/STRONG}"] = "</strong>";
        _rm["{NBSP}"] = "&nbsp;";
        _rm["“"] = "";
        _rm["”"] = "";
        _rm["’"] = "'";
        _ktot = Object.keys(_rm).length - 1;
        _kcnt = 0;
        for (_kcnt = 0; _kcnt <= _ktot; _kcnt++) {
            _strvalue = banano_getB4JKeyAt(_rm, _kcnt);
            _strrep = _rm[_strvalue];
            _stext = _stext.split(_strvalue).join(_strrep);
        }
        return _stext;
    };
    this.remdelim = function (_svalue, _delim) {
        if (self == null) self = this;
        var _ldelim;
        var _nvalue;
        if (_svalue.endsWith(_delim)) {
            _ldelim = _delim.length;
            _nvalue = _svalue;
            if (_nvalue.endsWith(_delim)) {
                _nvalue = _nvalue.substring(0, _nvalue.length - _ldelim);
            }
            return _nvalue;
        } else {
            return _svalue;
        }
    };
    this.addstyleattribute = function (_sprop, _svalue) {
        if (self == null) self = this;
        _sprop = _sprop.toLowerCase();
        _sprop = _sprop.trim();
        _svalue = _svalue.trim();
        _sprop = self.remdelim(_sprop, ":");
        _svalue = self.remdelim(_svalue, ";");
        _sprop = _sprop.trim();
        _svalue = _svalue.trim();
        if (_svalue.length > 0 && _sprop.length > 0) {
            if (_svalue.endsWith("!important") == false) {
                _svalue = _svalue + " !important";
            }
            self._styles[_sprop] = _svalue;
        }
        return self;
    };
    this.mvfield = function (_svalue, _iposition, _delimiter) {
        if (self == null) self = this;
        var _xpos;
        var _mvalues;
        var _tvalues;
        var _sb;
        var _startcnt;
        if (_svalue.length == 0) {
            return "";
        }
        _xpos = _svalue.indexOf(_delimiter);
        if (_xpos == -1) {
            return _svalue;
        }
        _mvalues = self.strparse(_delimiter, _svalue);
        _tvalues = 0;
        _tvalues = _mvalues.length - 1;
        switch ("" + _iposition) {
            case "" + -1:
                return _mvalues[_tvalues];
            case "" + -2:
                return _mvalues[_tvalues - 1];
            case "" + -3:
                _sb = new StringBuilder();
                _sb.isinitialized = true;
                _startcnt = 0;
                _sb.append(_mvalues[1]);
                for (_startcnt = 2; _startcnt <= _tvalues; _startcnt++) {
                    _sb.append(_delimiter);
                    _sb.append(_mvalues[_startcnt]);
                }
                return _sb.toString();
            default:
                _iposition = _iposition - 1;
                if (_iposition <= -1) {
                    return _mvalues[_tvalues];
                }
                if (_iposition > _tvalues) {
                    return "";
                }
                return _mvalues[_iposition];
        }
    };
    this.addclass = function (_value) {
        if (self == null) self = this;
        var _spclasses;
        var _strclass;
        _value = _value.split(" ").join(";");
        _spclasses = self.strparse(";", _value);
        for (var _strclassindex = 0; _strclassindex < _spclasses.length; _strclassindex++) {
            _strclass = _spclasses[_strclassindex];
            _strclass = _strclass.trim();
            if (_strclass.length > 0) {
                self._classes[_strclass] = _strclass;
            }
        }
        return self;
    };
    this.addattribute = function (_skey, _svalue) {
        if (self == null) self = this;
        self._properties[_skey] = _svalue;
        return self;
    };
    this.strparse = function (_delim, _inputstring) {
        if (self == null) self = this;
        var _outlist;
        var _commaloc;
        var _leftside;
        var _rightside;
        _outlist = [];
        _commaloc = 0;
        _outlist.length = 0;
        _outlist.length = 0;
        _commaloc = _inputstring.indexOf(_delim);
        while (_commaloc > -1) {
            _leftside = '';
            _leftside = _inputstring.substring(0, _commaloc);
            _rightside = '';
            _rightside = _inputstring.substring(_commaloc + 1);
            _outlist.push(_leftside);
            _inputstring = _rightside;
            _commaloc = _inputstring.indexOf(_delim);
        }
        _outlist.push(_inputstring);
        return _outlist;
    };
    this.join = function (_delimiter, _lst) {
        if (self == null) self = this;
        var _i;
        var _sb;
        _i = 0;
        _sb = new StringBuilder();
        _sb.isinitialized = true;
        _sb.append(_lst[0]);
        for (_i = 1; _i <= _lst.length - 1; _i++) {
            _sb.append(_delimiter).append(_lst[_i]);
        }
        return _sb.toString();
    };
    this.close = function () {
        if (self == null) self = this;
        var _sb;
        _sb = new StringBuilder();
        _sb.isinitialized = true;
        switch ("" + self._instance.toLowerCase()) {
            case "" + "img":
            case "" + "link":
            case "" + "meta":
            case "" + "input":
            case "" + "source":
            case "" + "hr":
            case "" + "br":
                self._doaproperclose = false;
                break;
        }
        if (self._doaproperclose == true) {
            _sb.append("</");
            _sb.append(self._instance);
            _sb.append(">");
        }
        _sb.append("\n");
        return _sb.toString();
    };
    this.getattr = function (_attr) {
        if (self == null) self = this;
        _attr = _attr.toLowerCase();
        if ((_attr in self._properties)) {
            return self._properties[_attr];
        } else {
            return "";
        }
    };
    this.tostring = function () {
        if (self == null) self = this;
        var _imgurl;
        var _lnk;
        var _sb;
        var _strcontent;
        var _sout;
        if (self._parentid != "") {
            self._id = self._parentid + self._id;
        }
        switch ("" + self._instance) {
            case "" + "img":
            case "" + "script":
                _imgurl = self.getattr("src");
                if (_imgurl.length > 0) {
                    _imgurl = _imgurl.toLowerCase();
                }
                break;
            case "" + "link":
                _lnk = self.getattr("href");
                if (_lnk.length > 0) {
                    _lnk = _lnk.toLowerCase();
                }
                break;
        }
        _sb = new StringBuilder();
        _sb.isinitialized = true;
        _sb.append(self.open());
        if (self._textafter == true) {
            self._contents.push(self._text);
        } else {
            self._contents.splice.apply(self._contents, [0, 0].concat(self._text));
        }
        for (var _strcontentindex = 0; _strcontentindex < self._contents.length; _strcontentindex++) {
            _strcontent = self._contents[_strcontentindex];
            if (_strcontent.length > 0) {
                _sb.append(_strcontent);
            }
        }
        _sb.append(self.close());
        _sout = _sb.toString();
        if (self._dontbreak.indexOf(self._instance) != -1) {
            _sout = _sout.split("\n").join("");
        }
        _sout = _sout.split("\n").join("");
        return _sout;
    };
}

function banano_bananojqm_jqmbutton() {
    var self;
    this._id = '';
    this._element = new banano_bananojqm_html5();
    this._href = '';
    this._text = '';
    this._theme = '';
    this._useajax = false;
    this._reverse = false;
    this._goback = false;
    this._transition = '';
    this._prefetch = false;
    this._showdialog = false;
    this._showpopup = false;
    this._inline = false;
    this._active = false;
    this._persiststate = false;
    this._icon = '';
    this._iconpos = '';
    this._position = '';
    this._enabled = false;
    this._mini = false;
    this._positionto = '';
    this._close = false;
    this._secondary = '';
    this._page = new banano_bananojqm_jqmpage();
    this.addcomponent = function (_comp) {
        if (self == null) self = this;
        self._element.addcontent(_comp);
    };
    this.removerole = function () {
        if (self == null) self = this;
        self._element.removeattrdata("role");
    };
    this.addclass = function (_sclass) {
        if (self == null) self = this;
        self._element.addclass(_sclass);
    };
    this.addstyle = function (_prop, _value) {
        if (self == null) self = this;
        self._element.addstyleattribute(_prop, _value);
    };
    this.addattribute = function (_prop, _value) {
        if (self == null) self = this;
        self._element.addattribute(_prop, _value);
    };
    this.initialize = function (_pg, _sid) {
        if (self == null) self = this;
        self._page = _pg;
        self._id = _sid.toLowerCase();
        self._element.initialize(self._id, "a");
        self._element.setattrdata("role", "button");
        self._useajax = true;
        self._reverse = false;
        self._goback = false;
        self._transition = "";
        self._prefetch = false;
        self._showdialog = false;
        self._showpopup = false;
        self._inline = false;
        self._active = false;
        self._persiststate = false;
        self._icon = "";
        self._iconpos = "";
        self._position = "";
        self._enabled = true;
        self._mini = false;
        self._positionto = "";
        self._close = false;
        return self;
    };
    this.targetpageid = function (_pgid) {
        if (self == null) self = this;
        var _slink;
        _slink = "#" + _pgid + "";
        self._href = _slink;
    };
    this.tostring = function () {
        if (self == null) self = this;
        var _span;
        if (self._close) {
            self._element.setattrdata("rel", "close");
        }
        if (self._positionto.length > 0) {
            self._element.setattrdata("position-to", self._positionto);
        }
        if (self._mini) {
            self._element.setattrdata("mini", "true");
        }
        self._element.setattrdata("theme", self._theme);
        if (self._enabled == false) {
            self._element.addclass("ui-disabled");
        }
        if (self._position.length > 0) {
            self._element.addclass(self._position);
        }
        if (self._icon.length > 0) {
            self._element.setattrdata("icon", self._icon);
        }
        if (self._iconpos.length > 0) {
            self._element.setattrdata("iconpos", self._iconpos);
        }
        if (self._active) {
            self._element.addclass("ui-btn-active");
        }
        if (self._persiststate) {
            self._element.addclass("ui-state-persist");
        }
        if (self._inline) {
            self._element.setattrdata("inline", "true");
        }
        if (self._showpopup) {
            self._element.setattrdata("rel", "popup");
            self._element.removeattrdata("role");
        }
        if (self._showdialog) {
            self._element.setattrdata("rel", "dialog");
        }
        if (self._transition.length > 0) {
            self._element.setattrdata("transition", self._transition);
        }
        if (self._prefetch) {
            self._element.setattrdata("prefetch", "true");
        }
        self._element.sethref(self._href);
        self._element.addcontent(self._text);
        if (self._secondary.length > 0) {
            _span = new banano_bananojqm_html5();
            _span.initialize("" + self._id + "span", "span");
            _span.addclass("ui-li-count");
            _span.addcontent(self._secondary);
            self._element.addcontent(_span.tostring());
        }
        if (self._useajax == false) {
            self._element.setattrdata("ajax", "false");
        }
        if (self._reverse) {
            self._element.setattrdata("direction", "reverse");
        }
        if (self._goback) {
            self._element.setattrdata("rel", "back");
        }
        return self._element.tostring();
    };
}

function banano_bananojqm_jqmcontainer() {
    var self;
    this._id = '';
    this._theme = '';
    this._element = new banano_bananojqm_html5();
    this._inset = false;
    this._visible = false;
    this._addbackbutton = false;
    this._fixed = false;
    this._inline = false;
    this._fullscreen = false;
    this._page = new banano_bananojqm_jqmpage();
    this.addclass = function (_sclass) {
        if (self == null) self = this;
        self._element.addclass(_sclass);
    };
    this.addstyle = function (_prop, _value) {
        if (self == null) self = this;
        self._element.addstyleattribute(_prop, _value);
    };
    this.addattribute = function (_prop, _value) {
        if (self == null) self = this;
        self._element.addattribute(_prop, _value);
    };
    this.addcontainer = function (_thiscont) {
        if (self == null) self = this;
        self.addcomponent(_thiscont.tostring());
    };
    this.addcontentlist = function (_lst) {
        if (self == null) self = this;
        self._element.addcontentlist(_lst);
    };
    this.addlink = function (_sid, _lnktext, _lnksecondary, _lnkurl, _lnktransition, _lnkicon) {
        if (self == null) self = this;
        var _a;
        var _span;
        _a = new banano_bananojqm_html5();
        _a.initialize(_sid, "a");
        _a.sethref(_lnkurl);
        _a.addcontent(_lnktext);
        if (_lnksecondary.length > 0) {
            _span = new banano_bananojqm_html5();
            _span.initialize("" + _sid + "span", "span");
            _span.addclass("ui-li-count");
            _span.addcontent(_lnksecondary);
            _a.addcontent(_span.tostring());
        }
        _a.setattrdata("transition", _lnktransition);
        _a.setattrdata("icon", _lnkicon);
        self.addcomponent(_a.tostring());
        self._page.addevent(_sid, "click");
    };
    this.sethref = function (_href) {
        if (self == null) self = this;
        self._element.sethref(_href);
    };
    this.settag = function (_tag) {
        if (self == null) self = this;
        self._element.settag(_tag);
    };
    this.setattrdata = function (_attr, _value) {
        if (self == null) self = this;
        self._element.setattrdata(_attr, _value);
    };
    this.addleftbutton = function (_bid, _btext, _burl, _bicon, _biconpos, _btransition, _breverse, _btheme) {
        if (self == null) self = this;
        var _btn;
        _btn = new banano_bananojqm_jqmbutton();
        _btn.initialize(self._page, _bid);
        _btn._theme = _btheme;
        _btn._text = _btext;
        _btn._href = _burl;
        _btn._icon = _bicon;
        _btn._iconpos = _biconpos;
        _btn._position = "ui-btn-left";
        _btn._transition = _btransition;
        _btn._reverse = _breverse;
        self.addbutton(_btn);
    };
    this.addbutton1 = function (_bid, _btext, _burl, _bicon, _biconpos, _btransition, _btheme) {
        if (self == null) self = this;
        var _btn;
        _btn = new banano_bananojqm_jqmbutton();
        _btn.initialize(self._page, _bid);
        _btn._theme = _btheme;
        _btn._text = _btext;
        _btn._href = _burl;
        _btn._icon = _bicon;
        _btn._iconpos = _biconpos;
        _btn._transition = _btransition;
        self.addbutton(_btn);
    };
    this.addrightbutton = function (_bid, _btext, _burl, _bicon, _biconpos, _btransition, _breverse, _btheme) {
        if (self == null) self = this;
        var _btn;
        _btn = new banano_bananojqm_jqmbutton();
        _btn.initialize(self._page, _bid);
        _btn._theme = _btheme;
        _btn._text = _btext;
        _btn._href = _burl;
        _btn._icon = _bicon;
        _btn._iconpos = _biconpos;
        _btn._position = "ui-btn-right";
        _btn._transition = _btransition;
        _btn._reverse = _breverse;
        self.addbutton(_btn);
    };
    this.initialize = function (_pg, _sid) {
        if (self == null) self = this;
        self._page = _pg;
        self._id = _sid.toLowerCase();
        self._element.initialize(self._id, "div");
        self._inset = false;
        self._visible = true;
        self._addbackbutton = false;
        self._fixed = false;
        self._inline = false;
        self._fullscreen = false;
    };
    this.addcomponent = function (_comp) {
        if (self == null) self = this;
        self._element.addcontent(_comp);
    };
    this.addbreak = function () {
        if (self == null) self = this;
        var _script;
        _script = "{BR}";
        self._element.addcontent(_script);
    };
    this.settext = function (_txt) {
        if (self == null) self = this;
        self._element.setcontents(_txt);
    };
    this.addbutton = function (_btn) {
        if (self == null) self = this;
        self._element.addcontent(_btn.tostring());
        self._page.addevent(_btn._id, "click");
    };
    this.addh1 = function (_sid, _scontent) {
        if (self == null) self = this;
        var _h1;
        _sid = _sid.toLowerCase();
        _h1 = new banano_bananojqm_html5();
        _h1.initialize(_sid, "h1");
        _h1.addcontent(_scontent);
        self._element.addcontent(_h1.tostring());
    };
    this.addh2 = function (_sid, _scontent) {
        if (self == null) self = this;
        var _h1;
        _sid = _sid.toLowerCase();
        _h1 = new banano_bananojqm_html5();
        _h1.initialize(_sid, "h2");
        _h1.addcontent(_scontent);
        self._element.addcontent(_h1.tostring());
    };
    this.addh4 = function (_sid, _scontent) {
        if (self == null) self = this;
        var _h1;
        _sid = _sid.toLowerCase();
        _h1 = new banano_bananojqm_html5();
        _h1.initialize(_sid, "h4");
        _h1.addcontent(_scontent);
        self._element.addcontent(_h1.tostring());
    };
    this.addh5 = function (_sid, _scontent) {
        if (self == null) self = this;
        var _h1;
        _sid = _sid.toLowerCase();
        _h1 = new banano_bananojqm_html5();
        _h1.initialize(_sid, "h5");
        _h1.addcontent(_scontent);
        self._element.addcontent(_h1.tostring());
    };
    this.addh6 = function (_sid, _scontent) {
        if (self == null) self = this;
        var _h1;
        _sid = _sid.toLowerCase();
        _h1 = new banano_bananojqm_html5();
        _h1.initialize(_sid, "h6");
        _h1.addcontent(_scontent);
        self._element.addcontent(_h1.tostring());
    };
    this.addh3 = function (_sid, _scontent) {
        if (self == null) self = this;
        var _h1;
        _sid = _sid.toLowerCase();
        _h1 = new banano_bananojqm_html5();
        _h1.initialize(_sid, "h3");
        _h1.addcontent(_scontent);
        self._element.addcontent(_h1.tostring());
    };
    this.addelement = function (_el) {
        if (self == null) self = this;
        self.addcomponent(_el.tostring());
    };
    this.addparagraph = function (_sid, _scontent) {
        if (self == null) self = this;
        var _h1;
        _sid = _sid.toLowerCase();
        _h1 = new banano_bananojqm_html5();
        _h1.initialize(_sid, "p");
        _h1.addcontent(_scontent);
        self._element.addcontent(_h1.tostring());
    };
    this.settheme = function (_stheme) {
        if (self == null) self = this;
        self._element.setattrdata("theme", _stheme);
    };
    this.tostring = function () {
        if (self == null) self = this;
        if (self._inline) {
            self._element.setattrdata("inline", "true");
        }
        if (self._fullscreen) {
            self._element.setattrdata("fullscreen", "true");
        }
        if (self._fixed) {
            self._element.setattrdata("position", "fixed");
        }
        if (self._addbackbutton) {
            self._element.setattrdata("add-back-btn", "true");
        }
        if (self._inset) {
            self._element.setattrdata("inset", "true");
        }
        self._element.setattrdata("theme", self._theme);
        if (self._visible == false) {
            return "";
        }
        return self._element.tostring();
    };
} /* BANano jCore */
var bananoglobal = this;
var DateTime;
var _BANUnique = 0;
const sleep = (milliseconds) => {
    return new Promise(resolve => setTimeout(resolve, milliseconds))
};

function BANAnoMethodVarsToMap(m, b, n) {
    if (b) {
        m['subname'] = n;
    }
    return m;
};

function BANanoExec(functionName, context, args) {
    var args = Array.prototype.slice.call(arguments, 2);
    var namespaces = functionName.split('.');
    var func = namespaces.pop();
    for (var i = 0; i < namespaces.length; i++) {
        context = context[namespaces[i]];
    }
    return context[func].apply(context, args);
};

function BANanoSuffixFromID(id) {
    var i = id.lastIndexOf('_');
    if (i > 0) {
        return id.substring(i + 1);
    }
    return -1;
};

function banano_isconnected(tag, returnMethod, obj) {
    var img = document.createElement('img');
    img.onerror = function () {
        obj[returnMethod](tag, false);
    };
    img.onload = function () {
        obj[returnMethod](tag, true);
    };
    img.src = './assets/donotdelete.gif?rand=' + ((new Date()).getTime());
}
async function banano_isconnectedWait() {
    return new Promise(function (resolve, reject) {
        var img = document.createElement('img');
        img.onerror = function () {
            resolve(false);
        };
        img.onload = function () {
            resolve(true);
        };
        img.src = './assets/donotdelete.gif?rand=' + ((new Date()).getTime());
    })
};

function setStyle(el, property, value) {
    el.style[property] = value;
}

function getStyle(el, property) {
    var style = window.getComputedStyle ? getComputedStyle(el, null) : el.currentStyle;
    return style[property];
}(function () {
    var DateFormat = "MM/dd/yyyy";
    var TimeFormat = "HH:mm:ss";
    var _TZOffset = new Date().getTimezoneOffset() * -1 / 60;
    var self = this;
    var DateTime = {
        DateParse: function (s) {
            var ddres = Date.parse(s);
            return DateTime.WithTZ(ddres).getTime();
        },
        TimeParse: function (s) {
            var dd = new Date();
            s = dd.format('yyyy-MM-dd') + ' ' + s;
            var ddres = Date.parse(s);
            return DateTime.WithTZ(ddres).getTime();
        },
        Date: function (n) {
            var ddres = DateTime.WithTZ(n);
            return ddres.format(DateFormat);
        },
        Time: function (n) {
            var ddres = DateTime.WithTZ(n);
            return ddres.format(TimeFormat);
        },
        GetDateFormat: function () {
            return DateFormat;
        },
        SetDateFormat: function (s) {
            DateFormat = s;
        },
        GetTimeFormat: function () {
            return TimeFormat;
        },
        SetTimeFormat: function (s) {
            TimeFormat = s;
        },
        Add: function (dd, y, m, d) {
            var ddres = DateTime.WithTZ(dd);
            var res = DateTime.InnerAdd(ddres, y, 'y');
            res = DateTime.InnerAdd(res, m, 'm');
            res = DateTime.InnerAdd(res, d, 'd');
            return res.getTime();
        },
        InnerAdd: function (d, c, t) {
            c = (c === undefined) ? 0 : c;
            var result = null;
            switch (t) {
                case 'mill':
                    result = new Date(d.setMilliseconds(d.getMilliseconds() + c));
                    break;
                case 's':
                    result = new Date(d.setSeconds(d.getSeconds() + c));
                    break;
                case 'min':
                    result = new Date(d.setMinutes(d.getMinutes() + c));
                    break;
                case 'h':
                    result = new Date(d.setHours(d.getHours() + c));
                    break;
                case 'd':
                    result = new Date(d.setDate(d.getDate() + c));
                    break;
                case 'm':
                    result = new Date(d.setMonth(d.getMonth() + c));
                    break;
                case 'y':
                    result = new Date(d.setFullYear(d.getFullYear() + c));
                    break;
                default:
                    console.error("[timeSolver.js] Input Type Error");
                    break;
            }
            return result;
        },
        WithTZ: function (n) {
            if (_TZOffset != new Date().getTimezoneOffset() * -1 / 60) {
                var d = DateTime.InnerAdd(new Date(n), new Date(n).getTimezoneOffset() / 60, 'h');
                d = DateTime.InnerAdd(d, _TZOffset, 'h');
                return d;
            } else {
                return new Date(n);
            }
        },
        Now: function () {
            return new Date().getTime();
        },
        GetYear: function (n) {
            return DateTime.WithTZ(new Date(n)).getFullYear();
        },
        GetMonth: function (n) {
            return DateTime.WithTZ(new Date(n)).getMonth() + 1;
        },
        GetDayOfMonth: function (n) {
            return DateTime.WithTZ(new Date(n)).getDate();
        },
        GetDayOfYear: function (n) {
            var t = new Date(n);
            var dayCount = [0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334];
            var mn = t.getMonth();
            var dn = t.getDate();
            var dayOfYear = dayCount[mn] + dn;
            var year = t.getFullYear();
            var isLeap = false;
            if ((year & 3) != 0) {
                isLeap = false;
            } else {
                isLeap = ((year % 100) != 0 || (year % 400) == 0);
            }
            if (mn > 1 && isLeap) dayOfYear++;
            return dayOfYear;
        },
        GetDayOfWeek: function (n) {
            return DateTime.WithTZ(new Date(n)).getDay() + 1;
        },
        GetHour: function (n) {
            return DateTime.WithTZ(new Date(n)).getHours();
        },
        GetMinute: function (n) {
            return DateTime.WithTZ(new Date(n)).getMinutes();
        },
        GetSecond: function (n) {
            return DateTime.WithTZ(new Date(n)).getSeconds();
        },
        GetTimeZoneOffsetAt: function (n) {
            if (_TZOffset != new Date().getTimezoneOffset() * -1 / 60) {
                return _TZOffset;
            } else {
                return new Date(n).getTimezoneOffset() * -1 / 60;
            }
        },
        GetWeekInYear: function (n) {
            var onejan = new Date(n.getFullYear(), 0, 1);
            return Math.ceil((((n - onejan) / 86400000) + onejan.getDay() + 1) / 7);
        },
        GetWeekInMonth: function (n, exact) {
            var month = n.getMonth(),
                year = n.getFullYear(),
                firstWeekday = new Date(year, month, 1).getDay(),
                lastDateOfMonth = new Date(year, month + 1, 0).getDate(),
                offsetDate = n.getDate() + firstWeekday - 1,
                index = 1,
                weeksInMonth = index + Math.ceil((lastDateOfMonth + firstWeekday - 7) / 7),
                week = index + Math.floor(offsetDate / 7);
            if (exact || week < 2 + index) return week;
            return week === weeksInMonth ? index + 5 : week;
        },
        TicksPerDay: function () {
            return 86400000;
        },
        TicksPerHour: function () {
            return 3600000;
        },
        TicksPerMinute: function () {
            return 60000;
        },
        TicksPerSecond: function () {
            return 1000;
        },
        TimeZoneOffset: function () {
            return _TZOffset;
        },
        SetTimeZone: function (n) {
            _TZOffset = n;
        }
    };
    if (typeof module !== 'undefined' && typeof module.exports !== 'undefined') {
        module.exports = DateTime;
    } else {
        if (typeof window !== 'undefined') {
            window.DateTime = DateTime;
        } else {
            bananoglobal.DateTime = DateTime;
        }
    }
})();
var dateFormat = function () {
    var token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
        timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
        timezoneClip = /[^-+\dA-Z]/g,
        pad = function (val, len) {
            val = String(val);
            len = len || 2;
            while (val.length < len) val = "0" + val;
            return val;
        };
    return function (date, mask, utc) {
        var dF = dateFormat;
        if (arguments.length == 1 && Object.prototype.toString.call(date) == "[object String]" && !/\d/.test(date)) {
            mask = date;
            date = undefined;
        }
        date = date ? new Date(date) : new Date;
        if (isNaN(date)) throw SyntaxError("invalid date");
        if (mask.slice(0, 4) == "UTC:") {
            mask = mask.slice(4);
            utc = true;
        }
        var _ = utc ? "getUTC" : "get",
            d = date[_ + "Date"](),
            D = date[_ + "Day"](),
            m = date[_ + "Month"](),
            y = date[_ + "FullYear"](),
            H = date[_ + "Hours"](),
            M = date[_ + "Minutes"](),
            s = date[_ + "Seconds"](),
            L = date[_ + "Milliseconds"](),
            o = utc ? 0 : date.getTimezoneOffset(),
            DD = DateTime.GetDayOfYear(date),
            w = DateTime.GetWeekInYear(date),
            W = DateTime.GetWeekInMonth(date, true),
            flags = {
                d: d,
                dd: pad(d),
                E: dF.i18n.dayNames[D],
                EE: dF.i18n.dayNames[D + 7],
                M: m + 1,
                MM: pad(m + 1),
                MMM: dF.i18n.monthNames[m],
                MMMM: dF.i18n.monthNames[m + 12],
                yy: String(y).slice(2),
                yyyy: y,
                h: H % 12 || 12,
                K: pad(H % 12 || 12),
                H: H,
                HH: pad(H),
                m: M,
                mm: pad(M),
                s: s,
                ss: pad(s),
                S: pad(L > 99 ? Math.round(L / 10) : L),
                a: H < 12 ? "AM" : "PM",
                Z: utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
                z: utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
                X: utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
                o: (o > 0 ? "-" : "+") + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
                u: D,
                D: DD,
                w: w,
                W: W
            };
        return mask.replace(token, function ($0) {
            return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
        });
    };
}();
dateFormat.i18n = {
    dayNames: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
    monthNames: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"]
};
Date.prototype.format = function (mask, utc) {
    return dateFormat(this, mask, utc);
};
String.prototype.equalsIgnoreCase = function (otherString) {
    return (this.toUpperCase().localeCompare(otherString.toUpperCase()) === 0);
};
String.prototype.contains = function (otherString) {
    return (this.indexOf(otherString) > -1);
};
String.prototype.getBytes = function () {
    var utf8 = [];
    var str = this;
    for (var i = 0; i < str.length; i++) {
        var charcode = str.charCodeAt(i);
        if (charcode < 0x80) utf8.push(charcode);
        else if (charcode < 0x800) {
            utf8.push(0xffffffc0 | (charcode >> 6), 0xffffff80 | (charcode & 0x3f));
        } else if (charcode < 0xd800 || charcode >= 0xe000) {
            utf8.push(0xffffffe0 | (charcode >> 12), 0xffffff80 | ((charcode >> 6) & 0x3f), 0xffffff80 | (charcode & 0x3f));
        } else {
            utf8.push(0xef, 0xbf, 0xbd);
        }
    }
    return utf8;
};

function banano_bytesToString(array) {
    var str = '',
        i;
    var data = new Uint8Array(array);
    for (i = 0; i < data.length; i++) {
        var value = data[i];
        if (value < 0x80) {
            str += String.fromCharCode(value);
        } else if (value > 0xBF && value < 0xE0) {
            str += String.fromCharCode((value & 0x1F) << 6 | data[i + 1] & 0x3F);
            i += 1;
        } else if (value > 0xDF && value < 0xF0) {
            str += String.fromCharCode((value & 0x0F) << 12 | (data[i + 1] & 0x3F) << 6 | data[i + 2] & 0x3F);
            i += 2;
        }
    }
    return str;
};

function banano_getB4JKeyAt(outof, index) {
    var getkeyatkeycounter = 0;
    for (var getkeyatkey in outof) {
        if (outof.hasOwnProperty(getkeyatkey)) {
            if (getkeyatkeycounter == index) {
                return getkeyatkey;
            }
            getkeyatkeycounter++;
        }
    }
    return '';
};

function banano_getB4JValueAt(outof, index) {
    var getkeyatkeycounter = 0;
    for (var getkeyatkey in outof) {
        if (outof.hasOwnProperty(getkeyatkey)) {
            if (getkeyatkeycounter == index) {
                return outof[getkeyatkey];
            }
            getkeyatkeycounter++;
        }
    }
    return '';
};

function StringBuilder() {
    this.strings = new Array("");
};
StringBuilder.prototype.append = function (value) {
    var self = this;
    if (value) {
        this.strings.push(value);
    }
    return self;
};
StringBuilder.prototype.insert = function (offset, value) {
    var self = this;
    var str = this.strings.join("");
    this.strings = new Array("");
    this.strings.push([str.slice(0, offset), value, str.slice(offset)].join(''));
    return self;
};
StringBuilder.prototype.remove = function (startoffset, endoffset) {
    var self = this;
    var str = this.strings.join("");
    this.strings = new Array("");
    this.strings.push([str.slice(0, startoffset), str.slice(endoffset)].join(''));
    return self;
};
StringBuilder.prototype.length = function () {
    return this.strings.join("").length;
};
StringBuilder.prototype.toString = function () {
    return this.strings.join("");
};

function Param(obj) {
    if (typeof (obj) === 'string' || Object.prototype.toString.call(obj) === '[object FormData]') return obj;
    if (/application\/json/i.test(settings.headers['Content-type']) || Object.prototype.toString.call(obj) === '[object Array]') return JSON.stringify(obj);
    var encoded = [];
    for (var prop in obj) {
        if (obj.hasOwnProperty(prop)) {
            encoded.push(encodeURIComponent(prop) + '=' + encodeURIComponent(obj[prop]));
        }
    }
    return encoded.join('&');
};

function banano_sf(_text, _onlynbsp) {
    try {
        var _s = new StringBuilder();
        var _v = '' + _text;
        if (_onlynbsp) {
            _v = _v.split("{NBSP}").join(" ");
        } else {
            _v = _v.split("(\r\n|\n\r|\r|\n)").join("<br>");
            _v = _v.split("{B}").join("<b>");
            _v = _v.split("{/B}").join("</b>");
            _v = _v.split("{I}").join("<i>");
            _v = _v.split("{/I}").join("</i>");
            _v = _v.split("{U}").join("<ins>");
            _v = _v.split("{/U}").join("</ins>");
            _v = _v.split("{SUB}").join("<sub>");
            _v = _v.split("{/SUB}").join("</sub>");
            _v = _v.split("{SUP}").join("<sup>");
            _v = _v.split("{/SUP}").join("</sup>");
            _v = _v.split("{BR}").join("<br>");
            _v = _v.split("{WBR}").join("<wbr>");
            _v = _v.split("{NBSP}").join("&nbsp;");
            _v = _v.split("{AL}").join("<a rel=\"nofollow\" target=\"_blank\" href=\"");
            _v = _v.split("{AT}").join("\">");
            _v = _v.split("{/AL}").join("</a>");
            _v = _v.split("{AS}").join(" title=\"");
            _v = _v.split("{/AS}").join("\"");
            while (_v.indexOf("{C:") > -1) {
                _v = self.replacefirst(_v, "{C:", "<span style=\"color:");
                _v = self.replacefirst(_v, "}", "\">");
                _v = self.replacefirst(_v, "{/C}", "</span>");
            }
            _v = _v.split("{CODE}").join("<pre><code>");
            _v = _v.split("{/CODE}").join("</code></pre>");
            while (_v.indexOf("{ST:") > -1) {
                _v = self.replacefirst(_v, "{ST:", "<span style=\"");
                _v = self.replacefirst(_v, "}", "\">");
                _v = self.replacefirst(_v, "{/ST}", "</span>");
            }
            var _start = _v.indexOf("{IC:");
            while (_start > -1) {
                var _stop = _v.indexOf("{/IC}");
                var _vv = "";
                if (_stop > 0) {
                    _vv = _v.substring(_start, _stop + 5);
                } else {
                    break;
                }
                var _iconcolor = _vv.substring(4, 11);
                var _iconname = _vv.substring(12, _vv.length - 5);
                var _repl = "";
                switch (_iconname.substring(0, 3).toLowerCase()) {
                    case "mdi":
                        _repl = "<i style=\"color: " + _iconcolor + "\" class=\"" + _iconname + "\"></i>";
                        break;
                    case "fa ":
                        _repl = "<i style=\"color: " + _iconcolor + "\" class=\"" + _iconname + "\"></i>";
                        break;
                    case "fa-":
                        _repl = "<i style=\"color: " + _iconcolor + "\" class=\"" + _iconname + "\"></i>";
                        break;
                    default:
                        _repl = "<i style=\"color: " + _iconcolor + "\" class=\"material-icons\">" + _iconname + "</i>";
                        break;
                }
                _v = _v.split(_vv).join(_repl);
                _start = _v.indexOf("{IC:");
            }
        }
        _s.append(_v);
        return _s.toString();
    } catch (err) {
        console.log(err.message + ' ' + err.stack);
    }
};

function replacefirst(_s, _searchfor, _replacewith) {
    try {
        var _i = _s.indexOf(_searchfor);
        if (_i > -1) {
            return _s.substring(0, _i) + _replacewith + _s.substring(_i + _searchfor.length);
        } else {
            return _s;
        }
    } catch (err) {
        console.log(err.message + ' ' + err.stack);
    }
};
var _banano_bananojqmtest = new banano_bananojqmtest();
var _banano_bananojqmtest_home = new banano_bananojqmtest_home();

function banano_bananojqmtest_home() {
    var self;
    this._app = new banano_bananojqm_jqmapp();
    this._page = new banano_bananojqm_jqmpage();
    this._id = "index";
    this.create = function (_thisapp) {
        if (self == null) self = this;
        var _ew;
        self._app = _thisapp;
        self._page.initialize(self._app, self._id);
        self._page._title = "Movie List";
        self._page._header._fixed = true;
        self._page._header.addrightbutton("mi", "Movie Info", "#index", "camera", "notext", "slide", false, "");
        self._page._header.addh1("", self._page._title);
        _ew = new banano_bananojqm_jqmcontainer();
        _ew.initialize(self._page, "ew");
        _ew.addclass("example-wrapper");
        _ew.addbutton1("btnsearch", "Search", "#", "search", "right", "", "");
        _ew.addparagraph("moviesfound", "");
        _ew.addbreak();
        self._page._content.addcontainer(_ew);
        self._page._footer._fixed = true;
        self._page._footer.addh1("", "Copyrights 2019");
    };
    this.btnsearch_click = function (_event) {
        if (self == null) self = this;
        _event.stopPropagation();
        console.log(_event.target.id);
    };
}

function banano_bananojqmtest() {
    var self;
    this._appname = "BANanoJQMTest";
    this._app = new banano_bananojqm_jqmapp();
    this.banano_ready = function () {
        if (self == null) self = this;
        self._app.initialize(self._appname);
        _banano_bananojqmtest_home.create(self._app);
        self._app.addpage(_banano_bananojqmtest_home, _banano_bananojqmtest_home._page);
    };
}
_banano_bananojqmtest.banano_ready();