﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7
@EndOfDesignText@
#IgnoreWarnings:12
Sub Class_Globals
	Public ID As String
	Private Element As HTML5
	Public HREF As String
	Public Text As String
	Public Theme As String
	Public UseAjax As Boolean
	Public Reverse As Boolean
	Public GoBack As Boolean
	Public Transition As String
	Public Prefetch As Boolean
	Public ShowDialog As Boolean
	Public ShowPopUp As Boolean
	Public Inline As Boolean
	Public Active As Boolean
	Public PersistState As Boolean
	Public Icon As String
	Public IconPos As String
	Public Position As String
	Public Enabled As Boolean
	Public Mini As Boolean
	Public PositionTo As String
	Public Close As Boolean
	Public Secondary As String
	Public Page As JQMPage
End Sub

Sub AddComponent(comp As String)
	Element.AddContent(comp)
End Sub

Sub RemoveRole
	Element.removeAttrData("role")
End Sub

Sub AddClass(sclass As String)
	Element.addClass(sclass)
End Sub

Sub AddStyle(prop As String, value As String)
	Element.AddStyleAttribute(prop,value)
End Sub

Sub AddAttribute(prop As String, value As String)
	Element.AddAttribute(prop,value)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(pg As JQMPage, sid As String) As JQMButton
	Page = pg
	ID = sid.tolowercase
	Element.Initialize(ID,"a")
	Element.setAttrData("role", "button")
	'Element.addClass("ui-btn") 
	UseAjax = True
	Reverse = False
	GoBack = False
	Transition = ""
	Prefetch = False
	ShowDialog = False
	ShowPopUp = False
	Inline = False
	Active = False
	PersistState = False
	Icon = ""
	IconPos = ""
	Position = ""
	Enabled = True
	Mini = False
	PositionTo = ""
	Close = False
	Return Me
End Sub

Sub TargetPageID(pgID As String)
	Dim slink As String = $"#${pgID}"$
	HREF = slink
End Sub

Sub ToString As String
	If Close Then
		Element.setAttrData("rel", "close")
	End If
	If PositionTo.Length > 0 Then
		Element.setAttrData("position-to", PositionTo)
	End If
	If Mini Then
		Element.setAttrData("mini", "true")
	End If
	Element.setAttrData("theme", Theme)
	
	If Enabled = False Then
		Element.addClass("ui-disabled")
	End If
	If Position.Length > 0 Then
		Element.addClass(Position)
	End If
	If Icon.Length > 0 Then
		Element.setAttrData("icon", Icon)
	End If
	If IconPos.Length > 0 Then
		Element.setAttrData("iconpos", IconPos)
	End If
	If Active Then
		Element.addClass("ui-btn-active")
	End If
	If PersistState Then
		Element.addClass("ui-state-persist")
	End If
	If Inline Then
		Element.setAttrData("inline", "true")
	End If
	If ShowPopUp Then
		Element.setAttrData("rel", "popup")
		Element.removeAttrData("role")
	End If
	If ShowDialog Then
		Element.setAttrData("rel", "dialog")
	End If
	If Transition.Length > 0 Then
		Element.setAttrData("transition", Transition)
	End If
	If Prefetch Then
		Element.setAttrData("prefetch", "true")
	End If
	Element.sethref(HREF)
	Element.AddContent(Text)
	If Secondary.Length > 0 Then
		Dim span As HTML5
		span.Initialize($"${ID}span"$,"span")
		span.addclass("ui-li-count")
		span.AddContent(Secondary)
		Element.AddContent(span.ToString)
	End If
	If UseAjax = False Then
		Element.setAttrData("ajax", "false")
	End If
	If Reverse Then
		Element.setAttrData("direction", "reverse")
	End If
	If GoBack Then
		Element.setAttrData("rel", "back")
	End If
	Return Element.tostring
End Sub